#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <dirent.h>
#include <unistd.h>
#include "ZTFinger.h"
#include <time.h>
#define byte unsigned char

#define BMP_PATH "/tmp/com.ztsave.finger"

int makdirs(char * muldir){
    int i,len;
    char str[512];
    strncpy(str,muldir,512);
    len = strlen(str);
    for(i = 0;i<len;i++){
        if(i > 0 && str[i] == '/'){
            str[i] = 0x00;
            if(access(str,0) != 0){
                if(mkdir(str,0777)){
                    return 1;
                }
            }
            str[i] = '/';    
        }    
    }
    if(len > 0 && access(str,0) != 0){
        if(mkdir(str,0777)){
            return 1;
        }
    }
    return 0;
}

int saveToBmp(int width, int height, char* name, unsigned char *Input)
{
    if(access(BMP_PATH,0) == -1){
        if(makdirs(BMP_PATH)){
            perror("create dir /tmp/com.ztsave.finger failed!!!\n");   
            return 0;     
        }    
    }

    char file[256] = {0};
    sprintf(file,"/%s/%s",BMP_PATH,name);

	FILE *ff;
	int i, j;
	if ((ff = fopen(file, "wb")) == NULL)
		return 0;

	fwrite(Input, 1078, sizeof(char), ff);

	for (i = 0; i <= height - 1; i++)
	{
		fseek(ff, 1078 * sizeof(char)+(height - 1 - i)*(width), SEEK_SET);
		fwrite(Input + 1078 + i * width, width, sizeof(char), ff);
	}

	fclose(ff);
	return 1;
}

int main (int argc, char * argv[]  )
{
    
	printf ( "可携带一个端口参数，例如：./sstest64 1 表示使用COM1口。默认 0 HID\n");
	printf ( "内部循环调用，按组合键Ctrl + C 可退出程序\n");
    int iPortNo = 0;
    if(argc == 2){
        iPortNo = atoi(argv[1]);
    }
    char extendPort = '9';
    int iBaudRate = 0;
    int iTimeOut = 10;
	char psFeature[512] = {0};
	char featureEx[512] = {0};
	char psTemplate[512] = {0};
    int iLength;
	char psErrInfo[32] = {0};
	char psVendorInfo[10] = {0};
	char psVersion[32] = {0};
	char psImgData[4][152*200] = {0};

	char uid[16] = {0};
	char oid[8] = {0};

	sprintf ( uid, "1234");

	sprintf ( oid, "5678");

    while(1){
        

		printf ( "探测手指\n");
		sleep(1);
		if(FPFingerDetect( iPortNo, extendPort, iBaudRate,iTimeOut, psErrInfo  )){
			printf("%s\n", psErrInfo);
		}else{
			printf("%s\n", psErrInfo);
			printf("探测到手指\n");
		}
        	sleep(1);
        	printf("请按一次指纹获取特征\n");
        	if(FPGetFeature( iPortNo, extendPort, iBaudRate,iTimeOut, psFeature, psErrInfo ,uid, oid))
        	{
        		printf("%s\n\n", psErrInfo);
        		continue;
        	}
        	printf("%s\n", psErrInfo);
        	printf("%s\n\n", psFeature);


         if(iPortNo == 0){
            	sleep(1);
            printf("获取图片\n");
            if(FH_GetFpImage(psImgData[0],  iTimeOut, psErrInfo)){
        		    printf("%s\n\n", psErrInfo);
            }else{
               printf("转变成BMP图片\n");
        	      char bmpImg[152*200 + 1078] = {0};
               FH_GetBMP(bmpImg, psImgData[0]);
               if(saveToBmp(152, 200, "finger.bmp", bmpImg)){
                    printf("BPM图片已生成 图片位置: /tmp/com.ztsave.finger/finger.bmp\n");
                }else{
                    printf("BPM图片生成失败\n");
                }
            }
         }


        	sleep(1);
        	printf ( "\n");
        	printf ( "获取指纹仪厂商\n");
        if(FPGetVendorInfo( iPortNo, extendPort, iBaudRate,iTimeOut, psVendorInfo, psErrInfo  )){
        		printf("%s\n", psErrInfo);
         }
        	printf ( "指纹仪厂商:%s\n\n", psVendorInfo );

        	sleep(1);
        	printf ( "\n");
        	printf ( "获取指纹仪版本\n");
        if(FPGetVersion( iPortNo, extendPort, iBaudRate,iTimeOut, psVersion, psErrInfo  )){
        		printf("%s\n", psErrInfo);
         }else{
        	   printf ( "指纹仪版本:%s\n", psVersion );
        }
    }

}

